﻿<?php 
/**
* @package Joomla
* @subpackage Servired
* -------------------------------------------------------------------------------------
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* -------------------------------------------------------------------------------------
* Versión de Barnatech S.L., mayo de 2008.
* Basado en notify_servired.php de Arluk Software, S.L.
* A su vez basado en notify.php del core de virtuemart.
*/

$mixResponse = (!empty($_POST) ? $_POST : $_GET);
if (isset($mixResponse['Ds_Order'])) {

	define('_VALID_MOS', '1');
	header('HTTP/1.0 200 OK');
	header('Content-type: text/html; charset=utf-8');

    /*** Joomla config ***/
		global $mosConfig_absolute_path, $mosConfig_live_site, $mosConfig_lang,
    	$mosConfig_mailfrom, $mosConfig_fromname;

		/*** access Joomla's configuration file ***/
        $my_path = dirname(__FILE__);
        if( file_exists($my_path."/../../../configuration.php")) {
            $absolute_path = dirname( $my_path."/../../../configuration.php" );
            require_once($my_path."/../../../configuration.php");
        } elseif( file_exists($my_path."/../../configuration.php")){
            $absolute_path = dirname( $my_path."/../../configuration.php" );
            require_once($my_path."/../../configuration.php");
        } elseif( file_exists($my_path."/configuration.php")){
            $absolute_path = dirname( $my_path."/configuration.php" );
            require_once( $my_path."/configuration.php" );
        } else {
            die( "Joomla Configuration File not found!" );
        }
        $absolute_path = realpath( $absolute_path );
        
        // Set up the appropriate CMS framework
        if (class_exists('JConfig')) {
        	
        	// Joomla 1.5
			define( '_JEXEC', 1 );
			define( 'JPATH_BASE', $absolute_path );
			define( 'DS', DIRECTORY_SEPARATOR );
			// Load the framework
			require_once ( JPATH_BASE . DS . 'includes' . DS . 'defines.php' );
			require_once ( JPATH_BASE . DS . 'includes' . DS . 'framework.php' );
			// create the mainframe object
			$mainframe = & JFactory::getApplication( 'site' );
			// Initialize the framework
			$mainframe->initialise();
			// load system plugin group
			jimport('joomla.plugin.helper');
			JPluginHelper::importPlugin( 'system' );
			// Set language
			$lang =& JFactory::getLanguage();
			$mosConfig_lang = $GLOBALS['mosConfig_lang'] = strtolower( $lang->getBackwardLang() );
			// Adjust the live site path
			$mosConfig_live_site = str_replace('/administrator/components/com_virtuemart', '', JURI::base());
			$mosConfig_absolute_path = JPATH_BASE;
			// Adjust other values
			$config =& JFactory::getConfig();
			$mosConfig_mailfrom = $config->mailfrom;
			$mosConfig_fromname = $config->fromname;
			
        } else {
        	
        	// Joomla 1.0
	        require_once($mosConfig_absolute_path. '/includes/joomla.php');
	        require_once($mosConfig_absolute_path. '/includes/database.php');
	        
        }

        // load Joomla Language File
        if (file_exists( $mosConfig_absolute_path. '/language/'.$mosConfig_lang.'.php' )) {
            require_once( $mosConfig_absolute_path. '/language/'.$mosConfig_lang.'.php' );
        } elseif (file_exists( $mosConfig_absolute_path. '/language/english.php' )) {
            require_once( $mosConfig_absolute_path. '/language/english.php' );
        }
    /*** END Joomla config ***/

    /*** VirtueMart part ***/
        require_once($mosConfig_absolute_path.'/administrator/components/com_virtuemart/virtuemart.cfg.php');
        include_once( ADMINPATH. '/compat.joomla1.5.php' );

		if (file_exists(CLASSPATH."Log/LogInit.php")) {

			// VirtueMart 1.1
			require_once( ADMINPATH. 'global.php' );

			/* @MWM1: Logging enhancements (file logging & composite logger). */
    	    $vmLogIdentifier = "notify.php";
        	require_once( CLASSPATH. 'Log/LogInit.php' );

	        global $sess;
		    $sess = new ps_session();

		} else {

			// VirtueMart 1.0
	        require_once( CLASSPATH. 'ps_main.php' );
	        require_once( CLASSPATH. 'ps_database.php' );

			require_once( CLASSPATH. 'Log/Log.php' );
			$vmLoggerConf = array(
				'buffering' => true
			);
			$vmLogger = &vmLog::singleton('display', '', '', $vmLoggerConf, PEAR_LOG_TIP);
			$GLOBALS['vmLogger'] =& $vmLogger;

			// Load language file.
			require_once( CLASSPATH. 'language.class.php' );
			if (file_exists( ADMINPATH. 'languages/'.$mosConfig_lang.'.php' ))
				require_once( ADMINPATH. 'languages/'.$mosConfig_lang.'.php' );
			else if (file_exists( ADMINPATH. 'languages/english.php' ))
				require_once( ADMINPATH. 'languages/english.php' );

		}

        require_once( CLASSPATH. 'ps_order.php' );
		require_once( CLASSPATH. 'ps_order_status.php' );
	/*** END VirtueMart part ***/

    // Read response from Servired system and update order status
	$mixResponse = (!empty($_POST) ? $_POST : $_GET);	// Reassignation needed, as Joomla 1.1 dereferences all local variables when including the framework.
	$Ds_Date = trim(stripslashes($mixResponse['Ds_Date'])); 
    $Ds_Hour = trim(stripslashes($mixResponse['Ds_Hour']));
    $Ds_Amount = trim(stripslashes($mixResponse['Ds_Amount']));
    $Ds_Currency = trim(stripslashes($mixResponse['Ds_Currency']));
    $Ds_Order = trim(stripslashes($mixResponse['Ds_Order']));
    $Ds_MerchantCode =  trim(stripslashes($mixResponse['Ds_MerchantCode']));
    $Ds_Terminal = trim(stripslashes($mixResponse['Ds_Terminal']));
    $Ds_Signature = trim(stripslashes($mixResponse['Ds_Signature']));
    $Ds_Response = trim(stripslashes($mixResponse['Ds_Response']));
    $Ds_TransactionType = trim(stripslashes($mixResponse['Ds_TransactionType']));
    $Ds_AuthorisationCode =  trim(stripslashes($mixResponse['Ds_AuthorisationCode']));

    // Get the order details from the database.
    if (substr($Ds_Order, -4, 1) == '-')
    	$strOrderId = substr($Ds_Order, 0, strlen($Ds_Order)-4);
    else
    	$strOrderId = $Ds_Order;

	$qv = "SELECT ".
			"`order_id`, `order_number`, `user_id`, `order_subtotal`, ".
			"`order_total`, `order_currency`, `order_tax`, ". 
			"`order_shipping_tax`, `coupon_discount`, `order_discount`, `order_status` ".
		"FROM `#__{vm}_orders` ". 
		"WHERE `order_id`='".intval($strOrderId)."' ";

	$db = new ps_DB;
	$db->query($qv);
	$db->next_record();

	$mixOrder = Array(
		'order_id' => $db->f("order_id"),
		'order_status' => $db->f("order_status"),
		'notify_customer' => 'Y'
	);

	// Cálculo de la firma esperada de los datos.
	global $ServiredConfig;
	require(dirname(__FILE__).'/prepend.php');
	$dblAmount = $db->f("order_total");
	$mixTransaction = CalculateTransactionSignature($Ds_Order, $dblAmount, $Ds_Response);

	$ps_order = new ps_order;
	$ps_order_status = new ps_order_status;

	if($Ds_Signature == $mixTransaction['Signature']){

		// Si $Ds_Response entre 0000 y 0099, la transacción ha ido bien.
		if (intval($Ds_Response)>=0 && intval($Ds_Response)<100 ) {

			// Update the order status.
			switch ($ServiredConfig['OnSuccessOrderStatus']) {
			    case 'C':
					$mixOrder['order_status'] = 'C';
			    	break;
			    case 'S':
					$mixOrder['order_status'] = 'S';
			    	break;
			    case 'P':
					$mixOrder['order_status'] = 'P';
			    	break;
			    default:
			        break;
			}
			$ps_order->order_status_update($mixOrder);
			
			if (!$ServiredConfig['OnSuccessMail'])
				$vmMailer = false;
			else {
				$vmMailer = vmCreateMail('', '',
					"Transacción SERVIRED en $mosConfig_live_site (correcta)", "
	Website: $mosConfig_live_site
	Transacción SERVIRED realizada
	------------------------------
		Pedido: ".$mixOrder['order_id']."
		Orden SERVIRED: $Ds_Order
		Estado de la transacción retornado por SERVIRED: $Ds_Response
		Estado del pedido: ".$ps_order_status->getOrderStatusName($mixOrder['order_status']));
			}
			
		} else {
			
			// Update the order status.
			switch ($ServiredConfig['OnCancelOrderStatus']) {
			    case 'P':
					$mixOrder['order_status'] = 'P';
			        break;
			    case 'X':
					$mixOrder['order_status'] = 'X';
			        break;
			    default:
			        break;
			}
			$ps_order->order_status_update($mixOrder);
			
			if (!$ServiredConfig['OnCancelMail'])
				$vmMailer = false;
			else {
				$vmMailer = vmCreateMail('', '',
					"Transacción SERVIRED en $mosConfig_live_site (no autorizada)", "
	Website: $mosConfig_live_site
	Intento de transacción SERVIRED fallida 
	---------------------------------------
		Pedido: ".$mixOrder['order_id']."
		Orden SERVIRED: $Ds_Order
		Estado de la transacción retornado por SERVIRED: $Ds_Response
		Estado del pedido: ".$ps_order_status->getOrderStatusName($mixOrder['order_status']));
			}
		}
		
	} else {
		
		$vmMailer = vmCreateMail('', '',
			"Transacción SERVIRED en $mosConfig_live_site (comprobación fallida)", "
	Website: $mosConfig_live_site
	Se recibió una firma de comprobación errónea en transacción SERVIRED
	--------------------------------------------------------------------
		Pedido: ".$mixOrder['order_id']." (".$ps_order_status->getOrderStatusName($mixOrder['order_status']).")
		Orden SERVIRED: $Ds_Order
		Estado de la transacción retornado por SERVIRED: $Ds_Response
		Cantidad pedido: $dblAmount
		Cantidad recibida: ".strval(intval($Ds_Amount)/100)."
		Firma recibida: $Ds_Signature
		Firma esperada: ".$mixTransaction['Signature']);
		
	}
	
	if ($vmMailer) {
		$vmMailer->AddAddress($mosConfig_mailfrom);
		$vmMailer->Send();
	}

}

?>