﻿<?php
/**
* @package Joomla
* @subpackage Servired
* -------------------------------------------------------------------------------------
* @copyright Copyright (C) 2008 Barnatech S.L. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
*/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );
require(dirname(__FILE__).'/prepend.php');

global $db, $user;
global $ServiredConfig, $mosConfig_absolute_path, $mosConfig_sitename;

if (!$db || !$db->f('order_id')) {
	$q = "SELECT order_id, order_total, order_status ".
			"FROM #__{vm}_orders ".
			"WHERE order_id='".intval($_REQUEST['order_id'])."';";
	$db = new ps_DB;
	$db->query($q);
	$db->next_record();
}
$strOrderStatus = $db->f('order_status');

if ($strOrderStatus === 'P' && $ServiredConfig['PaymentStatus'] != 'OK' && $ServiredConfig['PaymentStatus'] != 'PRINT_ORDER') {

	// Cálculo del hash para firmar los datos.
	$strOrderId = $db->f('order_id');
	// Añade un sufijo diferenciador aleatorio al código del pedido
	// de modo que el TPV distinga entre diferentes intentos de pago,
	// permitiendo así al usuario reintentar el pago de un pedido más tarde
	// si en primera instancia el pago falla o se cancela.
	$strUniqueOrderId = $strOrderId.'-'.strtoupper(substr(md5(microtime()), 0, 3));

	$dblAmount = $db->f('order_total');
	$mixTransaction = CalculateTransactionSignature($strUniqueOrderId, $dblAmount, ($ServiredConfig['SignatureType'] == SHA1_COMPLETE_EXTENDED ? $ServiredConfig['OperationType'].$ServiredConfig['URLMerchant'] : ''));

	// URL de retorno.
	$strUrlOK = $ServiredConfig['OnSuccessURL'];
	$strUrlOK .= (strpos($strUrlOK, '?') === false ? '?' : '&').'order_id='.$strOrderId.'&ok=1';

	$strUrlKO = $ServiredConfig['OnCancelURL'];
	$strUrlKO .= (strpos($strUrlKO, '?') === false ? '?' : '&').'order_id='.$strOrderId.'&ok=0';

	// Nombre del comprador.
	$strTitular = ($user->name ? $user->name : $user->first_name.' '.$user->last_name);

	// Idioma del TPV.
	ConfigureLanguage();

?>

<form id="secure_payment" action="<?php echo $ServiredConfig['URLTPV']; ?>" method="post">
<input type="submit" value="Pagar en modo seguro" />
<input type="hidden" name="Ds_Merchant_Amount"				value="<?php echo $mixTransaction['Amount']; ?>" />
<input type="hidden" name="Ds_Merchant_Currency"			value="<?php echo $ServiredConfig['Currency']; ?>" />
<input type="hidden" name="Ds_Merchant_Order"				value="<?php echo $mixTransaction['OrderId']; ?>" />
<input type="hidden" name="Ds_Merchant_ProductDescription"	value="<?php echo $ServiredConfig['ProductDescription']; ?>" />
<input type="hidden" name="Ds_Merchant_Titular"				value="<?php echo $strTitular; ?>" />
<input type="hidden" name="Ds_Merchant_MerchantCode"		value="<?php echo $ServiredConfig['Code']; ?>" />
<input type="hidden" name="Ds_Merchant_MerchantURL"			value="<?php echo $ServiredConfig['URLMerchant']; ?>" />
<input type="hidden" name="Ds_Merchant_UrlOK"				value="<?php echo $strUrlOK; ?>" />
<input type="hidden" name="Ds_Merchant_UrlKO"				value="<?php echo $strUrlKO; ?>" />
<input type="hidden" name="Ds_Merchant_MerchantName"		value="<?php echo $ServiredConfig['Name']; ?>" />
<input type="hidden" name="Ds_Merchant_ConsumerLanguage"	value="<?php echo $ServiredConfig['ConsumerLanguage']; ?>" />
<input type="hidden" name="Ds_Merchant_MerchantSignature"	value="<?php echo $mixTransaction['Signature']; ?>" />
<input type="hidden" name="Ds_Merchant_Terminal"			value="<?php echo $ServiredConfig['Terminal']; ?>" />
<input type="hidden" name="Ds_Merchant_TransactionType"		value="<?php echo $ServiredConfig['OperationType']; ?>" />
</form>
	
<?php
	if ($ServiredConfig['AutoSubmit'] && $ServiredConfig['PaymentStatus'] != 'KO') {
?>

<script type="text/javascript">
//<[CDATA[
document.getElementById('secure_payment').submit();
//]]>
</script>

<?php
	}
} else if ($ServiredConfig['PaymentStatus'] != 'PRINT_ORDER') {
	switch ($strOrderStatus) {
		case 'C':
		case 'S':
?>
<h1>Muchas gracias por su compra</h1>
<?php
			break;
		case 'X':
?>
<h1>Pedido cancelado</h1>
<?php
			break;
		case 'R':
?>
<h1>Pedido reembolsado</h1>
<?php
			break;
		default:
			break;
	}
}
?>